package com.rjconsultores.ventaboletos.blocos.bancobrasil;

import java.util.ArrayList;

import com.rjconsultores.ventaboletos.ArquivoRemessaItem;
import com.rjconsultores.ventaboletos.blocos.CabecalhoRemessa;
import com.rjconsultores.ventaboletos.blocos.DetalheObrigatorio;
import com.rjconsultores.ventaboletos.blocos.RodapeRemessa;

public class ArquivoRemessaBancoBrasil extends ArquivoRemessaItem {
	
	private int itemCount = 0;
	private int loteCount = 0;
	private int qteRegistroArq = 0;
	private int qteRegistroLote = 0;
	
	@Override
	public void setCabecalhoRemessa(CabecalhoRemessa cabecalhoRemessa) {

		if(cabecalhoRemessa instanceof CabecalhoRemessaBancoBrasil){
			super.setCabecalhoRemessa(cabecalhoRemessa);
			
			qteRegistroArq++;
			if(((CabecalhoRemessaBancoBrasil) cabecalhoRemessa).getCabecalhoLoteRemessaBancoBrasil() != null){
				qteRegistroArq++;
				qteRegistroLote++;
				loteCount++;
			}else{
				throw new RuntimeException("Falta cabecalho tipo: " + CabecalhoRemessaBancoBrasil.class.getName());
			}
		}else{
			throw new ClassCastException("Somente cabecalho tipo: " + CabecalhoRemessaBancoBrasil.class.getName());
		}	
	}

	@Override
	public void addTitulo(DetalheObrigatorio titulo) {
		if(this.titulos == null){
			this.titulos = new ArrayList<DetalheObrigatorio>();
			this.itemCount = 0;
		}
		
		if(titulo instanceof DetalheObrigatorioDadosTitulosBancoBrasil){
			
			titulo.setNumeroSequencialRegistro(++itemCount);
			((DetalheObrigatorioDadosTitulosBancoBrasil) titulo).setLoteServico(loteCount);
			qteRegistroArq++;
			qteRegistroLote++;
			if(((DetalheObrigatorioDadosTitulosBancoBrasil) titulo).getDetalheObrigatorioDadosPagadorBancoBrasil() != null){
				((DetalheObrigatorioDadosTitulosBancoBrasil) titulo).getDetalheObrigatorioDadosPagadorBancoBrasil().setNumeroSequencialRegistro(++itemCount);
				((DetalheObrigatorioDadosTitulosBancoBrasil) titulo).getDetalheObrigatorioDadosPagadorBancoBrasil().setLoteServico(loteCount);
				qteRegistroArq++;
				qteRegistroLote++;
			}
			
			this.titulos.add(titulo);
		}else{
			throw new ClassCastException("Somente cabecalho tipo: " + DetalheObrigatorioDadosTitulosBancoBrasil.class.getName());
		}
	}
	
	@Override
	public RodapeRemessa getRodapeRemessa() {
		
		((RodapeRemessaBancoBrasil) rodapeRemessa).setQtdLotes(loteCount);
		((RodapeRemessaBancoBrasil)rodapeRemessa).setQtdArquivos(qteRegistroArq);
		
		
		if(((RodapeRemessaBancoBrasil)rodapeRemessa).getRodapeRemessaLoteBancoBrasil() != null){
			((RodapeRemessaBancoBrasil)rodapeRemessa).getRodapeRemessaLoteBancoBrasil().setNumeroSequencialRegistro(qteRegistroLote);;

		}
		
		return this.rodapeRemessa;
	}
	
	@Override
	public void setRodapeRemessa(RodapeRemessa rodapeRemessa) {
		
		if(rodapeRemessa == null){
			throw new NullPointerException(RodapeRemessa.class.getName() + " não pode ser null...");
		}
		
		if(!(rodapeRemessa instanceof RodapeRemessaBancoBrasil)){
			throw new ClassCastException("Somente rodapé tipo: " + CabecalhoRemessaBancoBrasil.class.getName());
		}else{
			if(((RodapeRemessaBancoBrasil) rodapeRemessa).getRodapeRemessaLoteBancoBrasil() == null){	
				throw new RuntimeException("Falta rodapé tipo: " + RodapeRemessaLoteBancoBrasil.class.getName());
			}
			
			if(this.rodapeRemessa == null){
				qteRegistroArq++; //TrailerLote
				qteRegistroArq++;//TrailerArquivo
				qteRegistroLote++;
			}
			
			((RodapeRemessaBancoBrasil) rodapeRemessa).getRodapeRemessaLoteBancoBrasil().setNumeroSequencialRegistro(qteRegistroLote);
			((RodapeRemessaBancoBrasil) rodapeRemessa).getRodapeRemessaLoteBancoBrasil().setLoteServico(loteCount);
			((RodapeRemessaBancoBrasil) rodapeRemessa).setQtdArquivos(qteRegistroArq);
			((RodapeRemessaBancoBrasil) rodapeRemessa).setQtdLotes(loteCount);
			//((RodapeRemessaBancoBrasil) rodapeRemessa).setLoteServico(loteCount);
		}
		
		this.rodapeRemessa = rodapeRemessa;
	}

}
