package com.rjconsultores.ventaboletos.blocos.mercantil;

import java.math.BigDecimal;
import java.util.Date;

import com.rjconsultores.ventaboletos.blocos.DadosBoleto;
import com.rjconsultores.ventaboletos.blocos.DetalheObrigatorio;
import com.rjconsultores.ventaboletos.enuns.TipoInscricaoPagador;

public class DetalheObrigatorioMercantil implements DetalheObrigatorio, Cloneable {
	
	private Integer idBoletoFechamento;
	private String agenciaOrigem;
	private String numeroControleDoParticipante;
	private String nossoNumero;
	private String digitoVerificador;
	private Long cnpj;
	private Integer QtdPagamento = 0;
	private Integer codigoDeOcorrencia = 0;
	private Date dataOcorrencia;
	private String numeroDoDocumento;
	private Date vencimento;
	private BigDecimal ValorTitulo;
	private String especieDeTitulo;
	private Date emissao;
	private String instrucao1;
	private String instrucao2;
	private BigDecimal valorAtraso = BigDecimal.ZERO;
	private Date dataLimiteDesconto;
	private BigDecimal valorDesconto = BigDecimal.ZERO;
	private BigDecimal valorIOF = BigDecimal.ZERO;
	private BigDecimal valorAbatimentoConcedido = BigDecimal.ZERO;
	private TipoInscricaoPagador tipoInscricaoPagador;
	private Long numeroInscricaoPagador;
	private String nomePagador;
	private String enderecoCompletoPagador;
	private String bairro;	
	private String cidade;
	private String estado;	
	private String mensagem1;
	private String cepPrefixo;
	private String cepSufixo;
	private String sacadorAvalistaMensagem2;
	private Integer numeroSequencialRegistro;
	private Integer multaPercentual;
	private Integer numeroContrato;
	private Integer seuNumero;
	

	/*
			
	MultaPercentual"			
	MultaData"									
	"			
	IdentificacaoTitulo" 		
	AgenciaOrigem"								
	DigitoVerificador"			
				
	CNPJ"						
	QuantidadeMoeda"			
	CodigoOperacao"			
	CodigoMovimentacao"		
	SeuNumero"					
	DataVencimento"			
		
	CodigoBanco"				
	Agencia"							
	Aceite"													
	JurosDeMora"				
	DataLimiteDesconto"		
	DescontoConcedido"			
	IOF_Devido"				
	AbatimentoConcedido"		
	TipoInscricaoSacado"		
	NumeroInscricaoSacado"		
	NomeSacado"				
	EnderecoSacado"			
	BairroSacado"				
	CepSacado"					
	ComplementoCepSacado"		
	Cidade"					
	Estado"					
	SacadorAvalista"			
				
	CodigoMoeda"				
*/
	
	private DadosBoleto dadosBoleto;
	
	@Override
	public void setIdBoletoFechamento(Integer id) {
		this.idBoletoFechamento = id;
	}
	
	@Override
	public Integer getIdBoletoFechamento(){
		return this.idBoletoFechamento;
	}
	
	public DetalheObrigatorio clone() throws CloneNotSupportedException {
		return (DetalheObrigatorio) super.clone();
	}

	public String getAgenciaOrigem() {
		return agenciaOrigem;
	}

	public void setAgenciaOrigem(String agenciaOrigem) {
		this.agenciaOrigem = agenciaOrigem;
	}

	public String getNumeroControleDoParticipante() {
		return numeroControleDoParticipante;
	}

	public void setNumeroControleDoParticipante(String numeroControleDoParticipante) {
		this.numeroControleDoParticipante = numeroControleDoParticipante;
	}

	public String getNossoNumero() {
		return nossoNumero;
	}

	public void setNossoNumero(String nossoNumero) {
		this.nossoNumero = nossoNumero;
	}

	public String getDigitoVerificador() {
		return digitoVerificador;
	}

	public void setDigitoVerificador(String digitoVerificador) {
		this.digitoVerificador = digitoVerificador;
	}

	public Integer getQtdPagamento() {
		return QtdPagamento;
	}

	public void setQtdPagamento(Integer qtdPagamento) {
		QtdPagamento = qtdPagamento;
	}

	public Integer getCodigoDeOcorrencia() {
		return codigoDeOcorrencia;
	}

	public void setCodigoDeOcorrencia(Integer codigoDeOcorrencia) {
		this.codigoDeOcorrencia = codigoDeOcorrencia;
	}

	public Date getDataOcorrencia() {
		return dataOcorrencia;
	}

	public void setDataOcorrencia(Date dataOcorrencia) {
		this.dataOcorrencia = dataOcorrencia;
	}

	public String getNumeroDoDocumento() {
		return numeroDoDocumento;
	}

	public void setNumeroDoDocumento(String numeroDoDocumento) {
		this.numeroDoDocumento = numeroDoDocumento;
	}

	public Date getVencimento() {
		return vencimento;
	}

	public void setVencimento(Date vencimento) {
		this.vencimento = vencimento;
	}

	public BigDecimal getValorTitulo() {
		return ValorTitulo;
	}

	public void setValorTitulo(BigDecimal valorTitulo) {
		ValorTitulo = valorTitulo;
	}

	public String getEspecieDeTitulo() {
		return especieDeTitulo;
	}

	public void setEspecieDeTitulo(String especieDeTitulo) {
		this.especieDeTitulo = especieDeTitulo;
	}

	public Date getEmissao() {
		return emissao;
	}

	public void setEmissao(Date emissao) {
		this.emissao = emissao;
	}

	public String getInstrucao1() {
		return instrucao1;
	}

	public void setInstrucao1(String instrucao1) {
		this.instrucao1 = instrucao1;
	}

	public String getInstrucao2() {
		return instrucao2;
	}

	public void setInstrucao2(String instrucao2) {
		this.instrucao2 = instrucao2;
	}

	public BigDecimal getValorAtraso() {
		return valorAtraso;
	}

	public void setValorAtraso(BigDecimal valorAtraso) {
		this.valorAtraso = valorAtraso;
	}

	public Date getDataLimiteDesconto() {
		return dataLimiteDesconto;
	}

	public void setDataLimiteDesconto(Date dataLimiteDesconto) {
		this.dataLimiteDesconto = dataLimiteDesconto;
	}

	public BigDecimal getValorDesconto() {
		return valorDesconto;
	}

	public void setValorDesconto(BigDecimal valorDesconto) {
		this.valorDesconto = valorDesconto;
	}

	public BigDecimal getValorIOF() {
		return valorIOF;
	}

	public void setValorIOF(BigDecimal valorIOF) {
		this.valorIOF = valorIOF;
	}

	public BigDecimal getValorAbatimentoConcedido() {
		return valorAbatimentoConcedido;
	}

	public void setValorAbatimentoConcedido(BigDecimal valorAbatimentoConcedido) {
		this.valorAbatimentoConcedido = valorAbatimentoConcedido;
	}

	public TipoInscricaoPagador getTipoInscricaoPagador() {
		return tipoInscricaoPagador;
	}

	public void setTipoInscricaoPagador(TipoInscricaoPagador tipoInscricaoPagador) {
		this.tipoInscricaoPagador = tipoInscricaoPagador;
	}

	public Long getNumeroInscricaoPagador() {
		return numeroInscricaoPagador;
	}

	public void setNumeroInscricaoPagador(Long numeroInscricaoPagador) {
		this.numeroInscricaoPagador = numeroInscricaoPagador;
	}

	public String getNomePagador() {
		return nomePagador;
	}

	public void setNomePagador(String nomePagador) {
		this.nomePagador = nomePagador;
	}

	public String getEnderecoCompletoPagador() {
		return enderecoCompletoPagador;
	}

	public void setEnderecoCompletoPagador(String enderecoCompletoPagador) {
		this.enderecoCompletoPagador = enderecoCompletoPagador;
	}

	public String getMensagem1() {
		return mensagem1;
	}

	public void setMensagem1(String mensagem1) {
		this.mensagem1 = mensagem1;
	}

	public String getSacadorAvalistaMensagem2() {
		return sacadorAvalistaMensagem2;
	}

	public void setSacadorAvalistaMensagem2(String sacadorAvalistaMensagem2) {
		this.sacadorAvalistaMensagem2 = sacadorAvalistaMensagem2;
	}

	public Integer getNumeroSequencialRegistro() {
		return numeroSequencialRegistro;
	}

	public void setNumeroSequencialRegistro(Integer numeroSequencialRegistro) {
		this.numeroSequencialRegistro = numeroSequencialRegistro;
	}

	public DadosBoleto getDadosBoleto() {
		return dadosBoleto;
	}

	public void setDadosBoleto(DadosBoleto dadosBoleto) {
		this.dadosBoleto = dadosBoleto;
	}

	public Integer getMultaPercentual() {
		return multaPercentual;
	}

	public void setMultaPercentual(Integer multaPercentual) {
		this.multaPercentual = multaPercentual;
	}

	public String getCepPrefixo() {
		return cepPrefixo;
	}

	public void setCepPrefixo(String cepPrefixo) {
		this.cepPrefixo = cepPrefixo;
	}

	public String getCepSufixo() {
		return cepSufixo;
	}

	public void setCepSufixo(String cepSufixo) {
		this.cepSufixo = cepSufixo;
	}

	public Long getCnpj() {
		return cnpj;
	}

	public void setCnpj(Long cnpj) {
		this.cnpj = cnpj;
	}

	public Integer getNumeroContrato() {
		return numeroContrato;
	}

	public void setNumeroContrato(Integer numeroContrato) {
		this.numeroContrato = numeroContrato;
	}

	public Integer getSeuNumero() {
		return seuNumero;
	}

	public void setSeuNumero(Integer seuNumero) {
		this.seuNumero = seuNumero;
	}

	public String getBairro() {
		return bairro;
	}

	public void setBairro(String bairro) {
		this.bairro = bairro;
	}

	public String getCidade() {
		return cidade;
	}

	public void setCidade(String cidade) {
		this.cidade = cidade;
	}

	public String getEstado() {
		return estado;
	}

	public void setEstado(String estado) {
		this.estado = estado;
	}
}
