package com.rjconsultores.ventaboletos.layouts;

import com.rjconsultores.ventaboletos.enuns.BancoLayout;

public class CNABFactory {
	
	public static RemessaInterface createRemessa(BancoLayout bancoLayout){
		
		switch (bancoLayout) {
		case BRADESCO_400_Envio:
			return new BradescoFlatFile();
		case SANTANDER_400_Envio:
			return new SantanderFlatFile();
		case CAIXA_400_Envio:
			return new CaixaFlatFile();
		case MERCANTIL_400_Envio:
			return new MercantilFlatFile();
		case ITAU_400_Envio:
			return new ItauFlatFile();
		case BB_240_Envio:
			return new BancoBrasilFlatFile();
		case SICOOB_240_Envio:
			return new SicoobFlatFile();
		default:
			break;
		}
		
		return null;
	}

	public static RetornoInteface createRetorno(BancoLayout bancoLayout){
		
		switch (bancoLayout) {
		case BRADESCO_400_Retorno:
			return new BradescoProcessaRetorno();
		case ITAU_400_Retorno:
			return null;
		default:
			break;
		}
		
		return null;
	}
}
